<?php 
class sclassBuilder{
	
	public function get_ss_manifest_data($pid) {
		return get_post_meta($pid, 'srmehranclub_ss_manifest', true );
	}
	
	public function get_template_kit_temporary_url($pid) {
		$template_kit_folder_name = get_post_meta($pid, 'srmehranclub_ss_folder_name', true );
		$wp_upload_dir            = wp_upload_dir();
		return $wp_upload_dir['baseurl'] . '/srmehranclub-ss/' . $template_kit_folder_name . '/';
	}
	public function get_ssavailable_templates($pid) {
		$manifest_ss= $this->get_ss_manifest_data($pid);
		$manifest_has_ss_changed = false;
		
		if ( $manifest_ss && ! empty( $manifest_ss['templates'] ) ) {
			$templates_ss           = $manifest_ss['templates'];
			$screenshot_base_url = $this->get_template_kit_temporary_url($pid);
			
				foreach ( $templates_ss as $template_index => $template ) {
				$templates_ss[ $template_index ]['screenshot_url'] = $screenshot_base_url . $template['screenshot'];
				// Checking the additional template informatino strings for &amp; and converting to & so they display.
				if( ! empty( $template['metadata']['additional_template_information'] ) ) {
						$templates_ss[ $template_index ]['metadata']['additional_template_information'] = array_map( 'htmlspecialchars_decode', $template['metadata']['additional_template_information'] );
				}
				// Check if the name of the template has any characters that need decoding and convert them.
				$templates_ss[ $template_index ]['name'] = html_entity_decode($templates_ss[ $template_index ]['name']);
				// todo: this will be an array of imports into the page builder library
				// So we can show if the template has been imported already etc.
				if ( ! isset( $templates_ss[ $template_index ]['imports'] ) ) {
					$templates_ss[ $template_index ]['imports'] = array();
				}
				foreach ( $templates_ss[ $template_index ]['imports'] as $import_id => $imported_template_id ) {
					// check it still exists.
					$maybe_exists = get_post( $imported_template_id );
					if ( ! $maybe_exists || $maybe_exists->ID !== (int) $imported_template_id ) {
						$manifest_has_ss_changed = true;
						unset( $manifest['templates'][ $template_index ]['imports'][ $import_id ] );
					}
				}
			}
			if ( $manifest_has_ss_changed ) {
				// we've removed an imported template, need to refresh our manifest data.
				update_post_meta( $pid, 'srmehranclub_ss_manifest', $manifest );
			}
			return $templates_ss;
		
		}
		return array();
		
	}
}

?>