<?php 
class RecoderApi{
	public $slug='srmehranclub_ss';
	
	public $kit_id = null;
	
	public $builder = null;
	
	public function recordSmrhanEvent($data){
		 global $wpdb;
		 $tablename = $wpdb->prefix . "templates_download_history";
		 $resultii=$wpdb->insert($tablename,$data);
	}
	
	public function get_all_uploaded_srmehranclubKits() {
		return get_posts(
			array(
				'posts_per_page' => -1,
				'post_type'      =>'srmehranclub_ss',
			)
		);
	}
	
	
	/**
	 * Checks a template kid ID against the CPT database and loads if it's the correct type.
	 *
	 * @param $template_kit_id
	 *
	 * @return int|null
	 */
	public function load_ss_kit( $template_kit_id ) {
		$this->kit_id = null;
		$post         = get_post( $template_kit_id );
		if ($post->post_type=='srmehranclub_ss') {
			// Confirmed that the required ID is in fact one of our uploaded template kits.
			$builder = get_post_meta( $post->ID, 'srmehranclub_ss_builder', true );
			if ('elementor'== $builder ) {
				$this->kit_id = $post->ID;
			}
		}
		return $this->kit_id;
	}
	
	
	public function get_installed_template_ss_kit($template_kit_id){
		
		 $template_kit=$this->load_ss_kit( $template_kit_id );
		   $this->get_required_css($template_kit);
			// Start building up template kit response
		$template_kit_data = [
			'id'           => $template_kit_id,
			'title'        => $this->get_name($template_kit),
			'requirements' => [
				'theme'        => $this->get_required_theme($template_kit),
				'plugins'      => $this->get_required_plugins($template_kit),
				'css' 			   => $this->get_required_css($template_kit),
			],
			'templates'    => [],
		];
		//return $this->get_available_templates($template_kit);
		require_once('class-builder-loader.php');
		$obj_sclassBuilder=new sclassBuilder();
		// Loop over available templates and include any additional data we might need in the UI:
		foreach ( $obj_sclassBuilder->get_ssavailable_templates($template_kit) as $template_id => $template ) {
			$template['id']                   = $template_id;
			$template['template_kit_id']      = $template_kit_id;
			$template['unmet_requirements']   = $this->get_list_of_unmet_requirements( $template );
			$template_kit_data['templates'][] = $template;
		}

		return $template_kit_data;
		
		
		
	}
	
	public function get_name($template_kit) {
		$post = get_post($template_kit );
		return $post->post_title;
		
	}
	
	
	
	/**
	 * Get any unmet requirements for importing this template to WordPress
	 *
	 * @param $template array
	 *
	 * @return array
	 */
	public function get_list_of_unmet_requirements( $template ) {
		$unmet_requirements = array();
		if ( ! empty( $template['elementor_pro_required'] ) && ! class_exists( '\ElementorPro\Plugin' ) ) {
			$unmet_requirements[] = __( 'Elementor Pro is required for this Template.', 'template-kit-export' );
		}
		return $unmet_requirements;
	}
	
	

	
	
	public function get_manifest_data($template_kit) {
		return get_post_meta( $template_kit, 'srmehranclub_ss_manifest', true );
	}
	
	
	/**
	 * Gets the list of required plugins from metadata
	 *
	 * @return array
	 */
	public function get_required_plugins($template_kit) {
		 $manifest_data = $this->get_manifest_data($template_kit);
		require_once('class-required-plugin.php');
		
		$ssrPlugin=new Required_Pluginss_temp();
	
		return $ssrPlugin->check_for_required_plugins( ! empty( $manifest_data['required_plugins'] ) ? $manifest_data['required_plugins'] : array() );
		
	}
	
	/**
	 * Sets the css separator string in the customizer.
	 *
	 * @param $css_file
	 * @return string
	 */
	public function get_css_separator( $css_file ) {
		$css_separator = 'Srmehranclub Template Kit CSS: ' . esc_html( $this->get_name() . ' (' . $css_file .')');
		return $css_separator;
	}
	
	/**
	 * Gets the local path for the extracted ZIP file on the hosting account.
	 * Used to get the path for JSON files so page builders can load them in.
	 *
	 * @return string
	 */
	public function get_template_kit_temporary_folder() {
		$template_kit_folder_name = get_post_meta($template_kit, 'srmehranclub_ss_folder_name', true );
		$wp_upload_dir            = wp_upload_dir();
		$template_kit_folder_path = $wp_upload_dir['basedir'] . '/srmehranclub-ss/' . $template_kit_folder_name . '/';
		// Confirm we're pulling this data from the right location:
		if ( strpos( $template_kit_folder_path, $wp_upload_dir['basedir'] ) === 0 ) {
			return $template_kit_folder_path;
		}
		return null;
	}
	
	
	public function get_template_kit_temporary_folder256($template_kit) {
		$template_kit_folder_name = get_post_meta($template_kit, 'srmehranclub_ss_folder_name', true );
		$wp_upload_dir            = wp_upload_dir();
		$template_kit_folder_path = $wp_upload_dir['basedir'] . '/srmehranclub-ss/' . $template_kit_folder_name . '/';
		// Confirm we're pulling this data from the right location:
		if ( strpos( $template_kit_folder_path, $wp_upload_dir['basedir'] ) === 0 ) {
			return $template_kit_folder_path;
		}
		return null;
	}
	
	/**
	 * Given a temporary CSS filename (such as css/customizer.css) return the contents of that file.
	 *
	 * @param $css_filename
	 *
	 * @return string
	 */
	public function get_custom_css_data( $template_kit,$css_filename ) {
		
		
		 $temporary_template_kit_folder = $this->get_template_kit_temporary_folder256($template_kit);
		if ($temporary_template_kit_folder!='') {
			// check for the existence of this CSS file in the extracted folder:
			$full_css_file_path = realpath(trailingslashit( $temporary_template_kit_folder ) . $css_filename );
			
			
			
			if ( $full_css_file_path && file_exists( $full_css_file_path ) && 0 === strpos( $full_css_file_path, $temporary_template_kit_folder ) ) {
				// We have found the CSS file in the locally extracted ZIP file to import.
				return file_get_contents( $full_css_file_path );
			}
		}
		return 'fff';
	}

	
	
	/**
	 * Gets any required template css for this Template Kit
	 *
	 * @return array
	 */
	public function get_required_css($template_kit) {
		
		$manifest            = $this->get_manifest_data($template_kit);
		$custom_css_post     = wp_get_custom_css_post();
		$to_install_required = array();
		// For template kits we need to return the required css array to use
		if ( ! empty( $manifest['required_css'] ) ) {
			foreach ( $manifest['required_css'] as $required_css ) {
				$has_this_css_been_installed_already = false;
				if ( $custom_css_post && $custom_css_post->ID ) {
					// The user has customizer data on their website.
					$existing_customizer_css = $custom_css_post->post_content;
					$css_separator           = $this->get_css_separator( $required_css['file'] );
					if ( false !== strpos( $existing_customizer_css, $css_separator ) ) {
						// We have found this separator in the users customizer data.
						// Set the flag to true so we won't install this css snippet.
						$has_this_css_been_installed_already = true;
					}
				}
				if ( ! $has_this_css_been_installed_already ) {
					// The user hasn't installed this css before (or it's a fresh site with no customzer data yet)
					$required_css['css_preview'] = $this->get_custom_css_data( $template_kit,$required_css['file'] );
					$to_install_required[] = $required_css;
				}
			}
		}

		return $to_install_required;
	}
	
	/**
	 * Gets any required theme for this Template Kit
	 *
	 * @return array
	 */
	public function get_required_theme($template_kit) {
		$required_theme     = array(
			'slug' => 'hello-elementor',
			'name' => 'Hello Elementor',
		);
		$themes             = wp_get_themes();
		$current_theme      = wp_get_theme();
		$is_hello_installed = false;
		$is_hello_active    = false;
		foreach ( $themes as $theme ) {
			if ( $required_theme['slug'] === $theme->get_template() ) {
				$is_hello_installed = true;
			}
		}
		// get_template() checks for parent theme, so we handle a hello child theme using this just fine:
		if ( $required_theme['slug'] === $current_theme->get_template() ) {
			$is_hello_active = true;
		}
		$theme_action_url = admin_url( 'themes.php' );
		$theme_status     = $is_hello_active ? 'activated' : ( $is_hello_installed ? 'deactivated' : 'install' );
		if ( 'install' === $theme_status ) {
			// We want the user to install this theme
			$theme_action_url = add_query_arg( '_wpnonce', wp_create_nonce( 'install-theme_' . $required_theme['slug'] ), admin_url( 'update.php?action=install-theme&theme=' . $required_theme['slug'] ) );
		} elseif ( 'deactivated' === $theme_status ) {
			// We want the user to activate this theme
			$theme_action_url = add_query_arg( '_wpnonce', wp_create_nonce( 'switch-theme_' . $required_theme['slug'] ), admin_url( 'themes.php?action=activate&stylesheet=' . $required_theme['slug'] ) );
		}
		$required_theme['status'] = $theme_status;
		$required_theme['url']    = $theme_action_url;
		return $required_theme;
	}
	
}
?>