<?php 
class SrmehranImporter{
		
	public function installPremiumKit($pth){
		
		$wp_upload_dir                  = wp_upload_dir();
		$template_kit_base_path         = $wp_upload_dir['basedir'] . '/srmehranclub-ss/';
		$template_kit_random_folder     = md5( time() . NONCE_SALT );
		$template_kit_extract_directory = $template_kit_base_path . $template_kit_random_folder;
		wp_mkdir_p( $template_kit_extract_directory );
		// Prevent directory indexing so people cannot find the random template kit ID folders:
		touch( $template_kit_base_path . 'index.php' );
		global $wp_filesystem;

		require_once( ABSPATH . '/wp-admin/includes/file.php' );
		\WP_Filesystem();
		if ( ! $wp_filesystem instanceof \WP_Filesystem_Base ) {
			return new \WP_Error( 'zip_error', 'Failed to initialize WP Filesystem' );
		}
		
			
		
		$unzip_result = unzip_file( $pth, $template_kit_extract_directory );
		if ( $unzip_result !== true ) {
			if ( is_wp_error( $unzip_result ) ) {
				return $unzip_result;
			}

			return new \WP_Error( 'zip_error', 'Failed to unzip zip file' );
		}
		
		$extracted_zip_files = scandir( $template_kit_extract_directory );
		if ( $extracted_zip_files && is_array( $extracted_zip_files ) ) {
			$file_names = array_diff( $extracted_zip_files, array( '.', '..' ) );
		} else {
			$file_names = array();
		}
		if ( ! $file_names || ! in_array( 'manifest.json', $file_names, true ) ) {
			return new \WP_Error( 'zip_error', 'Please upload a valid Template Kit zip file' );
		}
		
		$manifest_data = json_decode( file_get_contents( $template_kit_extract_directory . '/manifest.json' ), true );
		
		
		
		$post_data = array(
			'post_title'  => $manifest_data['title'],
			'post_type'   =>'srmehranclub_ss',
			'post_status' => 'publish',
		);
		$post_id   = wp_insert_post( $post_data, true );

		if ( $post_id && ! is_wp_error( $post_id ) ) {
			// successfully stored this post. Add some metadata
			update_post_meta( $post_id, 'srmehranclub_ss_manifest', $manifest_data );
			update_post_meta( $post_id, 'srmehranclub_ss_folder_name', $template_kit_random_folder );
			update_post_meta( $post_id, 'srmehranclub_ss_builder', $manifest_data['page_builder'] );

			return $post_id;
		}
		
		return $pth ;
	}

	public function BlocksInstall($blocks_id,$blocksPth){
		
		$wp_upload_dir                  = wp_upload_dir();
		$template_kit_base_path         = $wp_upload_dir['basedir'] . '/srmehranclub-ss/';
		$template_kit_random_folder     = md5( time() . NONCE_SALT );
		$template_kit_extract_directory = $template_kit_base_path . $template_kit_random_folder;
		wp_mkdir_p( $template_kit_extract_directory );
		// Prevent directory indexing so people cannot find the random template kit ID folders:
		touch( $template_kit_base_path . 'index.php' );
		global $wp_filesystem;

		require_once( ABSPATH . '/wp-admin/includes/file.php' );
		\WP_Filesystem();
		if ( ! $wp_filesystem instanceof \WP_Filesystem_Base ) {
			return new \WP_Error( 'zip_error', 'Failed to initialize WP Filesystem' );
		}
		$unzip_result = unzip_file( $blocksPth, $template_kit_extract_directory );
		if ( $unzip_result !== true ) {
			if ( is_wp_error( $unzip_result ) ) {
				return $unzip_result;
			}

			return new \WP_Error( 'zip_error', 'Failed to unzip zip file' );
		}
		 $extracted_zip_files = scandir( $template_kit_extract_directory );
		if ( $extracted_zip_files && is_array( $extracted_zip_files ) ) {
			$file_names = array_diff( $extracted_zip_files, array( '.', '..' ) );
		} else {
			$file_names = array();
		}
		$getFile_data =$template_kit_extract_directory . '/'.$file_names[2];
		
			$source = \Elementor\Plugin::$instance->templates_manager->get_source( 'local' );
			$get_ss_result = $source->import_template( basename( $getFile_data ), $getFile_data );
			$block_ss_data = json_decode( file_get_contents( $getFile_data ), true );
			//unlink( $getFile_data );
			if ( is_wp_error( $get_ss_result ) ) {
				return $get_ss_result->get_error_message();
			}
			if ( $get_ss_result && $get_ss_result[0] && $get_ss_result[0]['template_id'] ) {
				$imported_ss_template_id = $get_ss_result[0]['template_id'];
				
				if ( $block_ss_data && ! empty( $block_ss_data['custom_css'] ) ) {
					$existing_customizer_css             = '';
					$css_separator                       = 'Srmehranclub Block  Kit CSS: ' . esc_html( $block_ss_data['kit_id'] );
					$custom_css_post                     = wp_get_custom_css_post();
					$has_this_css_been_installed_already = false;
					if ( $custom_css_post && $custom_css_post->ID ) {
						// The user has customizer data on their website.
						$existing_customizer_css = $custom_css_post->post_content;
						if ( false !== strpos( $existing_customizer_css, $css_separator ) ) {
							// We have found this separator in the users customizer data.
							// Set the flag to true so we won't install this css snippet.
							$has_this_css_been_installed_already = true;
						}
					}
					if ( ! $has_this_css_been_installed_already ) {
						// The user hasn't installed this css before (or it's a fresh site with no customzer data yet)
						$existing_customizer_css .= "\n\n/** Start $css_separator **/\n\n" . $block_data['custom_css'] . "\n\n/** End $css_separator **/\n\n";
						wp_update_custom_css_post( $existing_customizer_css );
					}
				}
				
				$ssrecord=[
					'type'=>'Blocks',
					'action'=>'BlocksInstall'.$blocks_id,
					'template_id'=>$blocks_id,
					'post_id'=>$imported_ss_template_id,
				];
				$rr=SrmehranApi::$objRecoder->recordSmrhanEvent($ssrecord);
			}
			
			$ssrecord['urledit']='post.php?post='.$imported_ss_template_id.'&action=elementor';
		return $ssrecord;
	}
	
	
	
	
	public function BlocksInstallByPop($blocks_id,$blocksPth){
		
		$wp_upload_dir                  = wp_upload_dir();
		$template_kit_base_path         = $wp_upload_dir['basedir'] . '/srmehranclub-ss/';
		$template_kit_random_folder     = md5( time() . NONCE_SALT );
		$template_kit_extract_directory = $template_kit_base_path . $template_kit_random_folder;
		wp_mkdir_p( $template_kit_extract_directory );
		// Prevent directory indexing so people cannot find the random template kit ID folders:
		touch( $template_kit_base_path . 'index.php' );
		global $wp_filesystem;

		require_once( ABSPATH . '/wp-admin/includes/file.php' );
		\WP_Filesystem();
		if ( ! $wp_filesystem instanceof \WP_Filesystem_Base ) {
			return new \WP_Error( 'zip_error', 'Failed to initialize WP Filesystem' );
		}
		$unzip_result = unzip_file( $blocksPth, $template_kit_extract_directory );
		if ( $unzip_result !== true ) {
			if ( is_wp_error( $unzip_result ) ) {
				return $unzip_result;
			}

			return new \WP_Error( 'zip_error', 'Failed to unzip zip file' );
		}
		 $extracted_zip_files = scandir( $template_kit_extract_directory );
		if ( $extracted_zip_files && is_array( $extracted_zip_files ) ) {
			$file_names = array_diff( $extracted_zip_files, array( '.', '..' ) );
		} else {
			$file_names = array();
		}
		$getFile_data =$template_kit_extract_directory . '/'.$file_names[2];
		
			$source = \Elementor\Plugin::$instance->templates_manager->get_source( 'local' );
			$get_ss_result = $source->import_template( basename( $getFile_data ), $getFile_data );
			$block_ss_data = json_decode( file_get_contents( $getFile_data ), true );
			//unlink( $getFile_data );
			if ( is_wp_error( $get_ss_result ) ) {
				return $get_ss_result->get_error_message();
			}
			if ( $get_ss_result && $get_ss_result[0] && $get_ss_result[0]['template_id'] ) {
				$imported_ss_template_id = $get_ss_result[0]['template_id'];
				
				if ( $block_ss_data && ! empty( $block_ss_data['custom_css'] ) ) {
					$existing_customizer_css             = '';
					$css_separator                       = 'Srmehranclub Block  Kit CSS: ' . esc_html( $block_ss_data['kit_id'] );
					$custom_css_post                     = wp_get_custom_css_post();
					$has_this_css_been_installed_already = false;
					if ( $custom_css_post && $custom_css_post->ID ) {
						// The user has customizer data on their website.
						$existing_customizer_css = $custom_css_post->post_content;
						if ( false !== strpos( $existing_customizer_css, $css_separator ) ) {
							// We have found this separator in the users customizer data.
							// Set the flag to true so we won't install this css snippet.
							$has_this_css_been_installed_already = true;
						}
					}
					if ( ! $has_this_css_been_installed_already ) {
						// The user hasn't installed this css before (or it's a fresh site with no customzer data yet)
						$existing_customizer_css .= "\n\n/** Start $css_separator **/\n\n" . $block_data['custom_css'] . "\n\n/** End $css_separator **/\n\n";
						wp_update_custom_css_post( $existing_customizer_css );
					}
				}
				
				$ssrecord=[
					'type'=>'Blocks',
					'action'=>'BlocksInstall'.$blocks_id,
					'template_id'=>$blocks_id,
					'post_id'=>$imported_ss_template_id,
				];
				$rr=SrmehranApi::$objRecoder->recordSmrhanEvent($ssrecord);
				
				
				// we have to return additional JSON data so Elementor can insert these widgets on the page.
				\Elementor\Plugin::$instance->editor->set_edit_mode( true );
				$db      = \Elementor\Plugin::$instance->db;
				$content = $db->get_builder($imported_ss_template_id); 
				if ( ! empty( $content ) ) {
					$content = \Elementor\Plugin::$instance->db->iterate_data( $content, function ( $element ) {
						$element['id'] = \Elementor\Utils::generate_random_string();

						return $element;
					} );
				} 
				
				
				$ssrecord['content'] = $content;
			}
			
			$ssrecord['urledit']='post.php?post='.$imported_ss_template_id.'&action=elementor';
		return $ssrecord;
	}
	
}

?>