<?php
/**
 * UI module.
 * Functions that render some output on the admin site are here.
 * This module also takes care of most hooks and Ajax calls.
 *
 * @since   4.0.0
 * @package SRMEHRAN_Dashboard
 */

/**
 * The UI class.
 */
class SRMEHRAN_Template_Admin_Ui {

	/**
	 * An object that defines all the URLs for the Template menu/submenu items.
	 *
	 * @var object
	 */
	public $page_urls = null;
	
	
	/**
	 * Identifies the currently displayed Template module. If current page is
	 * no Template page then this value stays false.
	 *
	 * @var bool|string
	 */
	public $current_module = false;

	/**
	 * Is the current admin screen a SRMEHRAN Template page?
	 *
	 * @var bool
	 */
	public $is_dashboard = false;
	
	/**
	 * Set up the UI module. This adds all the initial hooks for the plugin
	 *
	 * @since 4.0.0
	 * @internal
	 */
	public function __construct() {

		// Hook up our WordPress customizations.
		
		//add_action('init', array( $this, 'register_template_session' ));
		add_action( 'init', array( $this, 'setup_branding' ) );
		add_action('elementor/editor/footer',array( $this, 'admin_footer_modulefile'));
		add_action('admin_footer', array( $this,'admin_add_js_module'));
		
	}
	
// function register_template_session(){
    // if( ! session_id() ) {
        // session_start();
    // }
// }







	/*
	 * *********************************************************************** *
	 * *     INTERNAL ACTION HANDLERS
	 * *********************************************************************** *
	 */

	/**
	 * Register our plugin branding.
	 *
	 * I.e. Setup all the things that are NOT on the dashboard page but modify
	 * the look & feel of WordPress core pages.
	 *
	 * @since    1.0.0
	 * @internal Action hook
	 */
	public function setup_branding() {

		if ( ! is_admin() )
			return false;

		// Add the menu icon to the admin menu.
		if ( !is_multisite() )
			$menu_hook = 'admin_menu';

		// Setup Menus
		add_action(
			$menu_hook,
			array( $this, 'setup_menu' )
		);

	}


	

	public function isUserLogin(){
		
			$info=SRMEHRAN_Templtes::$api_handel->sr_get_ss_user_info();
			if(!empty($info['username_ss'])&&!empty($info['password_ss'])){
									$GetLogin=[
							'action'=>'GetUserLogin',
							'username'=>$info['username_ss'],
							'password'=>$info['password_ss']
						];
						$result=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$GetLogin);
						$result=json_decode($result);
						if($result->status=='success'){
							$_SESSION['user_result']=$result;
							return	$result=[
							'status'=>'success'];						
						
						}
						else{
							return	$result=[
							'status'=>'faild'];
						}
					}else{
						if(!empty($_POST['username'])&&!empty($_POST['password'])){
								$GetLogin=[
								'action'=>'GetUserLogin',
								'username'=>$_POST['username'],
								'password'=>$_POST['password']
							];
								$result=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$GetLogin);
								$result=json_decode($result);
								if($result->status=='success'){
									$_SESSION['user_result']=$result;
									SRMEHRAN_Templtes::$api_handel->sr_save_ss_user_to_db($_POST['username'], $_POST['password']);
								//	wp_safe_redirect('admin.php?page=srmehran-welcome');
									?>
									<script>
		window.location.href ="<?='admin.php?page=srmehran-welcome'?>";
		</script>
									<?php
									$_POST=[];
								return	$result=[
							'status'=>'success'];	
							
								}
								else{
									return	$result=[
											'status'=>'faild'];
								}
							}
					}
	}
	
	
	public function blocks_crypt( $string, $action = 'e' ) {
    // you may change these values to your own
    $secret_key = 'srmehranclub_coms';
    $secret_iv = 'fdsgsdfgfdgsfdgsfdgsdfgs';
 
    $output = false;
    $encrypt_method = "AES-256-CBC";
    $key = hash( 'sha256', $secret_key );
    $iv = substr( hash( 'sha256', $secret_iv ), 0, 16 );
 
    if( $action == 'e' ) {
        $output = base64_encode( openssl_encrypt( $string, $encrypt_method, $key, 0, $iv ) );
    }
    else if( $action == 'd' ){
        $output = openssl_decrypt( base64_decode( $string ), $encrypt_method, $key, 0, $iv );
    }
 
    return $output;
}
	
	
	/**
	 * Register the SRMEHRAN Dashboard menu structure.
	 *
	 * @since    1.0.0
	 * @internal Action hook
	 */
	public function setup_menu() {

		// Enqueue styles =====================================================.
		wp_enqueue_style(
			'srmehran-template-main-css',
			SRMEHRAN_Templtes::$template_site_info->plugin_url . 'css/template-main.css?v10.0',
			array()
		);
	
	wp_enqueue_script( 'smrhan_main_template',SRMEHRAN_Templtes::$template_site_info->plugin_url . 'js/smrhan_main_template.js?v10', array( 'jquery' ));
		
		
		//*****************************Includes Style And Js Files*****************/
		wp_register_style( 'Font_Awesome', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css' );
		wp_enqueue_style('Font_Awesome');
		
		//*****************************Includes Style And Js Files*****************/
		
		
		
		// Dashboard Main Menu.
		$add_template_page = add_menu_page(
			__( 'Srmehran Templates Kits', 'srmehran_templates' ),
			'Srmehran Templates Kits',
			'manage_options',
			'srmehran-welcome',
			array( $this, 'render_welcome_page' ),
			'dashicons-welcome-view-site'
		);
		
		
		$this->add_submenu(
			'srmehran-welcome',
			__( 'Srmehran Dev Dashboard', 'srmehran-welcome' ),
			__( 'Welcome', 'srmehran-welcome' ),
			array( $this, 'render_welcome_page' )
		);
		
		$info=SRMEHRAN_Templtes::$api_handel->sr_get_ss_user_info();
		
		if(!empty($info['username_ss'])&& !empty($info['password_ss'])){
		$add_template_page = $this->add_submenu(
				'premium-kits',
				__( 'Template Kits', 'Template Kits' ),
				__( 'Template Kits', 'Template Kits' ),
				array( $this, 'template_premium_kits' )
			);
			
			
		$add_template_page = $this->add_submenu(
				'free-kits',
				__( 'Free Kits', 'Free Kits' ),
				__( 'Free Kits', 'Free Kits' ),
				array( $this, 'template_free_kits' )
			);	
		
		///Free Blocks
		
		$add_template_page = $this->add_submenu(
				'free-blocks',
				__( 'Blocks', 'Blocks' ),
				__( 'Blocks', 'Blocks' ),
				array( $this, 'template_free_blocks' )
			);

		$add_template_page = $this->add_submenu(
				'installed-kits',
				__( 'Installed Kits', 'Installed Kits' ),
				__( 'Installed Kits', 'Installed Kits' ),
				array( $this, 'template_Installed_Kits' )
			);
			
		
			
		$add_template_page = $this->add_submenu(
				'template-Settings',
				__( 'Server Status', 'Server Status' ),
				__( 'Server Status', 'Server Status' ),
				array( $this, 'template_settings' )
			);
			
				
		$add_template_page = $this->add_submenu(
				'template-logout',
				__( 'Logout', 'Logout' ),
				__( 'Logout', 'Logout' ),
				array( $this, 'template_logout_ss' )
			);
		}
		
	}
	
	public function template_logout_ss(){
		delete_option('srmehran_Templtes_ss_credentials_username');
		delete_option('srmehran_Templtes_ss_credentials_password');
		?>
		<script>
		window.location.href ="<?='admin.php?page=srmehran-welcome'?>";
		</script>
		<?php
		//wp_redirect('admin.php?page=srmehran-welcome');
	}
	
	public function template_settings(){
		
		
		require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/userSettings.php');
	}
	
	public function render_welcome_page(){
		
		// Load Theme Page Content
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/header.php');
			
			 $info=SRMEHRAN_Templtes::$api_handel->sr_get_ss_user_info();
			 
			$is_login_user=$this->isUserLogin();
			if($is_login_user['status']=='faild'){
				$message='Invalid username or password';
			}else{
				$message='';
			}
			
			if(!empty($info['username_ss'])&& !empty($info['password_ss'])){
				
				
				
				
				$getMembershipDetail=[
			'action'=>'getMembershipDetails',
			'username'=>$_SESSION['user_result']->data->username
			];
			$membershipDetails=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getMembershipDetail);
			$membershipDetails=json_decode($membershipDetails);
			$_SESSION['stausactve']=$membershipDetails;
			$infogetr=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',['action'=>'imagesget']);
			$infogetr=json_decode($infogetr);
			 
			$ss_info=[
				'action'=>'user_ss_info',
				'username'=>$info['username_ss'],
				'site_name'=>get_bloginfo( 'name' ),
				'site_url'=>network_site_url( '/' ),
				'plan_name'=>($membershipDetails->status=='success')?$membershipDetails->data->name:'Free'
				
			];
			SRMEHRAN_Templtes::$api_handel->sr_update_ss_siteinfo($ss_info);
			
			$GetTotaldata=[
			'action'=>'GetTotalAvailableTemplates',
			];
			
			$GetTotalAvailableTemplates=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$GetTotaldata);
			$GetTotalAvailableTemplates=json_decode($GetTotalAvailableTemplates);
			
			 global $wpdb;
			 $tablename = $wpdb->prefix . "templates_download_history";
			$getallreadyInstalledkit=$wpdb->get_results("SELECT * FROM `$tablename` WHERE type!='import' AND id IN (
				SELECT MAX(id)
				FROM `$tablename`
				GROUP BY template_id
			)", ARRAY_A );
			
			// Load Theme Page Content Theme List
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/welcome.php');
			}else{
					// Load Theme Page Content Theme List
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/srmeharn_login.php');
			}
			

			// Load Theme Footer
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/footer.php');
	}

	public function getAlreadyInstalled($type){
		 global $wpdb;
			 $tablename = $wpdb->prefix . "templates_download_history";
			$getallreadyInstalled=$wpdb->get_results("SELECT template_id,post_id FROM `$tablename`  WHERE type='".$type."' AND id IN (
    SELECT MAX(id)
    FROM `$tablename`
    GROUP BY template_id
)", ARRAY_A );
			
			$installed=[];
			foreach($getallreadyInstalled as $ssvalue){
				$installed[$ssvalue['template_id']]=$ssvalue['post_id'];
				
			}
			return $installed;
	}
	
	
	public function getBrandNameBySS($ssId){
		$GetAllBrands=[
						'1'=>'ESSENTIAL ADDONS',
						'2'=>'WOOLENTOR PRO',
						'3'=>'HAPPY ELEMENTOR',
						'4'=>'PIOTNET ADDONS',
						'5'=>'ADDONS ELEMENTOR ',
						'6'=>'ANYWHERE ELEMENTOR',
						'7'=>'THE PLUS ADDONS',
						'8'=>'ULTIMATE ADDONS',
						'9'=>'WPKIT FOR ELEMENTOR',
						'10'=>'ASTRA TEMPLATES',
						'11'=>'SITEOCEANWP TEMPLATES',
						'12'=>'ENVATO TEMPLATES',
						'13'=>'TEMPLATEMONSTER TEMPLATES',
						'14'=>'PORTO TEMPLATES',
						'16'=>'SRMEHRANCLUB',
						'17'=>'MISCELLANEOUS BRAND',
						'18'=>'ELEMENTOR PRO',
						'19'=>'MASTER ADDONS',
						'20'=>'PRIME SLIDER',
						'21'=>'HT MEGA',
						'22'=>'CROCOBLOCK',
						'23'=>'THE PLUS ADD-ONS',
						'24'=>'POWERPACK',
						'25'=>'UNLIMITED ELEMENTS',
						'26'=>'ELEMENT PACK',
						'27'=>'PREMIUM ADD-ONS'
					];
			foreach($GetAllBrands as $keyss=>$value){
				if($ssId==$keyss){
					echo  $value;
				}else{
					echo  '';
				}
			}		
	}
	
	public function getAlreadyinstalledById($actionid){
		 global $wpdb;
			 $tablename = $wpdb->prefix . "templates_download_history";
			$getallreadyInstalled=$wpdb->get_results("SELECT template_id,post_id FROM `$tablename` WHERE action='".$actionid."' AND id IN (
    SELECT MAX(id)
    FROM `$tablename`
    GROUP BY template_id
)", ARRAY_A );
			
			$installed=[];
			foreach($getallreadyInstalled as $ssvalue){
				$installed[$ssvalue['template_id']]=$ssvalue['post_id'];
				
			}
			return $installed;
	}

	public function template_premium_kits(){
		// Load Theme Page Content
		if (isset($_GET["ss_page"])) {
			$page  = $_GET["ss_page"]; 
		} 
		else{ 
			$page=1;
		}
			$limit = 12;
			$start_from = ($page-1) * $limit;
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/header.php');
			$getTemplate=[
			'action'=>'GetCatgoaires',
			'type'=>'1'
			];
			
			$getTemplateCatgories=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getTemplate);
			$getprodcut=[
			'action'=>'GetProducts',
			'main_cat_id'=>'1',
			'price_type'=>'2',
			'limit'=>$limit,
			'start_from'=>$start_from
			];
			
			if(isset($_GET['premium_kits_by_cat'])){
				$id=$this->blocks_crypt($_GET['premium_kits_by_cat'],'d');
				$getprodcut['sub_cat_id']=$id;
			}
			
			if(isset($_GET['premium_kits_by_brand'])){
				$id=$this->blocks_crypt($_GET['premium_kits_by_brand'],'d');
				$getprodcut['brand_id']=$id;
			}
			
			if(@$_GET['_bremium']=='256'){
				$getprodcut['q']=$_GET['q'];
			}
			
			if(isset($_GET['srmehran-project_id'])){
				$jsonData = array(
		    'action' => 'install',
		    'params' =>$_GET
		);
		$jsonData = json_encode($jsonData);

				die();
				
			}
			
			
		
			
			$getProdcutApi=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getprodcut);
			
			
			
			    $infogetr=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',['action'=>'imagesget']);
			$infogetr=json_decode($infogetr);
			$installed=$this->getAlreadyInstalled('PremiumTemplate');
			// Load Theme Page Content Theme List
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/premium_kits.php');

			// Load Theme Footer
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/footer.php');
	}

	public function template_free_kits(){
		
		if (isset($_GET["ss_page"])) {
			$page  = $_GET["ss_page"]; 
		} 
		else{ 
			$page=1;
		}
			$limit = 12;
			$start_from = ($page-1) * $limit;
		// Load Theme Page Content
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/header.php');

				$getTemplate=[
			'action'=>'GetCatgoaires',
			'type'=>'1'
			];
			
			$getTemplateCatgories=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getTemplate);



				$free_kits=[
			'action'=>'GetProducts',
			'main_cat_id'=>'1',
			'price_type'=>'1',
			'limit'=>$limit,
			'start_from'=>$start_from
			];
			
			if(isset($_GET['free_kits_by_cat'])){
				$id=$this->blocks_crypt($_GET['free_kits_by_cat'],'d');
				$free_kits['sub_cat_id']=$id;
			}
			
			if(@$_GET['_freeremium']=='340'){
				$free_kits['q']=$_GET['q'];
			}
			
			
			if(isset($_GET['free_kits_by_brand'])){
				$id=$this->blocks_crypt($_GET['free_kits_by_brand'],'d');
				$free_kits['brand_id']=$id;
			}
			
			$free_kits_Api=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$free_kits);
			
			$infogetr=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',['action'=>'imagesget']);
			$infogetr=json_decode($infogetr);
			$installedff=$this->getAlreadyInstalled('Free_kits');
			// Load Theme Page Content Theme List
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/free_kits.php');

			// Load Theme Footer
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/footer.php');
	}

	public function template_free_blocks(){
		
		
		$infogetr=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',['action'=>'imagesget']);
			$infogetr=json_decode($infogetr);
		// Load Theme Page Content
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/header.php');
			$getblocks=[
			'action'=>'GetCatgoaires',
			'type'=>'2'
			];
			$getblocksCatgories=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$getblocks);
			
			
			
			if(isset($_GET['getblocksCatgories'])){
				
				$id=$this->blocks_crypt($_GET['getblocksCatgories'],'d');
				
					
		if (isset($_GET["ss_page_b"])) {
			$page_b  = $_GET["ss_page_b"]; 
		} 
		else{ 
			$page_b=1;
		}
			$limit = 12;
			$start_from = ($page_b-1) * $limit;
				
			$free_blocksprodcut=[
			'action'=>'GetProducts',
			'main_cat_id'=>'2',
			'sub_cat_id'=>$id,
			'limit'=>$limit,
			'start_from'=>$start_from
			];
			
			if(isset($_GET['c'])){
				$free_blocksprodcut['price_type']=$_GET['c'];
			
			}
			
			$getfree_blocksProdcutApi=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',$free_blocksprodcut);
					// Load single catgory page
					
					
					
					$installedgetFrreBlock=$this->getAlreadyInstalled('Blocks');
	
				require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/free_ blocks_single.php');
				
			}else{
				// Load Theme Page Content Theme List
				require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/free_ blocks.php');
			}
			

			// Load Theme Footer
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/footer.php');
	}
	
	public function get_installed_SRMEHRAN_Templtes_kits(){
		$infogetr=SRMEHRAN_Templtes::$api_handel->mehran_request_ajax('https://srmehranclub.com/',['action'=>'imagesget']);
			$infogetr=json_decode($infogetr);
		require_once('class-events-records.php');
		require_once('class-builder-loader.php');
		$obj_RecoderApi=new RecoderApi();
		$obj_sclassBuilder=new sclassBuilder();
		$uploaded_srmehranclub_kits=$obj_RecoderApi->get_all_uploaded_srmehranclubKits();
		$installed_ss_kits = [];
		try {
			foreach ( $uploaded_srmehranclub_kits as $template_srmehranclub_kit ) {
				$template_srmehranclub_kit_id = $template_srmehranclub_kit->ID;
				$getdata=$obj_sclassBuilder->get_ssavailable_templates($template_srmehranclub_kit_id);
				
				$installed_ss_kits[]       = [
						'id'             => $template_srmehranclub_kit_id,
						'screenshot_url' => $getdata[0]['screenshot_url'],
						'title'          => $template_srmehranclub_kit->post_title,
						'template_count' => count( $getdata ),
					];
			}
		}
		catch ( \Exception $e ) {

		}
		return $installed_ss_kits;
	}
	
	
	public function getInsttaledKitbyId($id){
		require_once('class-events-records.php');
		$obj_RecoderApi=new RecoderApi();
		
		if ($id === 'all' ) {
			// User is requesting templates from all kits.
			$all_template_ss_data = [
				'id'           => 'all',
				'title'        => 'All Installed Kits',
				'requirements' => [],
				'templates'    => [],
			];
			$installed_kitsss=$this->get_installed_SRMEHRAN_Templtes_kits();
			foreach ( $installed_kitsss as $installed_ss_kit ) {
				$installed_kit_ss_data = $obj_RecoderApi->get_installed_template_ss_kit( $installed_ss_kit['id'] );
				if ( $installed_kit_ss_data && ! is_wp_error( $installed_kit_ss_data ) ) {
					$all_template_ss_data['templates'] = $all_template_ss_data['templates'] + $installed_kit_ss_data['templates'];
				}
			}
			
		}else{
			$template_kit_id = (int) $id;

			 $all_template_ss_data =  $obj_RecoderApi->get_installed_template_ss_kit($template_kit_id);
			
		}
		
			// Now we split the template data into groups.
		// This list of templates come from the "Template Kit Export" plugin:
		$template_types = [
			'single-page'         => __( 'Single: Page', 'template-kit-export' ),
			'single-home'         => __( 'Single: Home', 'template-kit-export' ),
			'single-post'         => __( 'Single: Post', 'template-kit-export' ),
			'single-product'      => __( 'Single: Product', 'template-kit-export' ),
			'single-404'          => __( 'Single: 404', 'template-kit-export' ),
			'archive-blog'        => __( 'Archive: Blog', 'template-kit-export' ),
			'archive-product'     => __( 'Archive: Product', 'template-kit-export' ),
			'archive-search'      => __( 'Archive: Search', 'template-kit-export' ),
			'archive-category'    => __( 'Archive: Category', 'template-kit-export' ),
			'section-header'      => __( 'Header', 'template-kit-export' ),
			'section-footer'      => __( 'Footer', 'template-kit-export' ),
			'section-popup'       => __( 'Popup', 'template-kit-export' ),
			'section-hero'        => __( 'Hero', 'template-kit-export' ),
			'section-about'       => __( 'About', 'template-kit-export' ),
			'section-faq'         => __( 'FAQ', 'template-kit-export' ),
			'section-contact'     => __( 'Contact', 'template-kit-export' ),
			'section-cta'         => __( 'Call to Action', 'template-kit-export' ),
			'section-team'        => __( 'Team', 'template-kit-export' ),
			'section-map'         => __( 'Map', 'template-kit-export' ),
			'section-features'    => __( 'Features', 'template-kit-export' ),
			'section-pricing'     => __( 'Pricing', 'template-kit-export' ),
			'section-testimonial' => __( 'Testimonial', 'template-kit-export' ),
			'section-product'     => __( 'Product', 'template-kit-export' ),
			'section-services'    => __( 'Services', 'template-kit-export' ),
			'section-stats'       => __( 'Stats', 'template-kit-export' ),
			'section-countdown'   => __( 'Countdown', 'template-kit-export' ),
			'section-portfolio'   => __( 'Portfolio', 'template-kit-export' ),
			'section-gallery'     => __( 'Gallery', 'template-kit-export' ),
			'section-logo-grid'   => __( 'Logo Grid', 'template-kit-export' ),
			'section-clients'     => __( 'Clients', 'template-kit-export' ),
			'section-other'       => __( 'Other', 'template-kit-export' ),
		];
		
		$templates_grouped = [];
		foreach ( $all_template_ss_data['templates'] as $template_id => $template ) {
			$template_group = ! empty( $template['metadata'] ) && ! empty( $template['metadata']['template_type'] ) && $template['metadata']['template_type'] !== 'global-styles' ? $template['metadata']['template_type'] : false;
			if ( $template_group ) {
				if ( ! isset( $templates_grouped[ $template_group ] ) ) {
					$templates_grouped[ $template_group ] = [
						'title'     => isset( $template_types[ $template_group ] ) ? $template_types[ $template_group ] : $template_group,
						'templates' => [],
					];
				}
				$templates_grouped[ $template_group ]['templates'][] = $template;
			} else {
				// If something doesn't have a valid template type, remove it from the list.
				unset( $all_template_ss_data['templates'][ $template_id ] );
			}
		}
		$all_template_ss_data['templates']        = array_values( $all_template_ss_data['templates'] );
		$all_template_ss_data['templatesGrouped'] = array_values( $templates_grouped );
		
		
		// We report any missing default settings that are required for template kits.
		if ( ! isset( $all_template_ss_data['requirements']['settings'] ) ) {
			$all_template_ss_data['requirements']['settings'] = [];
		}
		// Check Elementor default colors and fonts are set.
		// Elementor stores the string 'yes' in the WordPress database if these options are active, and an empty string if these options are not active.
		$is_elementor_color_schemes_disabled_already      = get_option( 'elementor_disable_color_schemes' );
		$is_elementor_typography_schemes_disabled_already = get_option( 'elementor_disable_typography_schemes' );
		if ( $is_elementor_color_schemes_disabled_already !== 'yes' ) {
			$all_template_ss_data['requirements']['settings'][] = [
				'name'         => 'Elementor default color schemes',
				'setting_name' => 'elementor_disable_color_schemes'
			];
		}
		if ( $is_elementor_typography_schemes_disabled_already !== 'yes' ) {
			$all_template_ss_data['requirements']['settings'][] = [
				'name'         => 'Elementor default typography schemes',
				'setting_name' => 'elementor_disable_typography_schemes'
			];
		}
		return $all_template_ss_data;
		//return $id;
	}
	
	public function template_Installed_Kits(){
		
		$getallInstalled=$this->get_installed_SRMEHRAN_Templtes_kits();
		

		// Load Theme Page Content
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/header.php');
			if(isset($_GET['instkitId'])){
				$getId=$this->blocks_crypt($_GET['instkitId'],'d');
				
				
				$getData=$this->getInsttaledKitbyId($getId);
				$actionid='import_json'.$getId;
				$getinstalledtemplate=$this->getAlreadyinstalledById($actionid);
				
				require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/get_installed_kits.php');
			}else{
				require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/installed_kits.php');
			}
			// echo "<pre>";
			// print_r($_GET);
			// echo "<pre>";
			// Load Theme Page Content Theme List
			

			// Load Theme Footer
			require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/footer.php');
	}
	
function admin_footer_modulefile() {
		
		$getallInstalled=$this->get_installed_SRMEHRAN_Templtes_kits();
	
    	require_once(SRMEHRAN_Templtes::$template_site_info->plugin_path.'templates/adminModule_file.php');
	
}
	
	
	
function admin_add_js_module() {

	?>
	
	<?php
}
	
	
	
	

		/**
	 * Official way to add new submenu items to the SRMEHRAN Dashboard.
	 * The Dashboard styles are automatically enqueued for the new page.
	 *
	 * @since 4.0.0
	 *
	 * @param  string   $id         The ID is prefixed with 'srmehran-' for the page body class.
	 * @param  string   $title      The documents title-tag.
	 * @param  string   $label      The menu label.
	 * @param  callable $handler    Function that is executed to render page content.
	 * @param  string   $capability Optional. Required capability. Default: manage_options.
	 *
	 * @return string Page hook_suffix of the new menu item.
	 */
	public function add_submenu( $id, $title, $label, $handler, $capability = 'manage_options' ) {
		static $Registered = array();

		// Prevent duplicates of the same menu item.
		if ( isset( $Registered[ $id ] ) ) {
			return;
		}
		$Registered[ $id ] = true;

		if ( false === strpos( $id, 'srmehran' ) ) {
			$id = 'srmehran-' . $id;
		}

		$page = add_submenu_page(
			'srmehran-welcome',
			$title,
			$label,
			$capability,
			$id,
			$handler
		);
		
		return $page;
	}

}